#
# flagments
#

#------------------------------------------------------------#

smtp = Net::SMTP.new( host, port )
smtp.start( helo ) do
  # write from string (not safe if mail is big)
  smtp.sendmail string, from, to

  # write from file (safe)
  smtp.sendmail input_file, from, to

  # write from array of string (not safe)
  smtp.sendmail arr, from, to

  # write little string at one iteration
  smtp.ready( from, to ) do |f|
    f.write str1
    f.write str2
    f.write str3
  end
end

#------------------------------------------------------------#

Net::POP.start( addr, port, account, passwd ) do |pop|
  pop.each do |mail|
    print mail.top 25   # print header & 25 lines
    print mail.pop      # print all

    # write to string (not safe if mail is too big)
    str = mail.pop

    # write to file (safe)
    mail.pop( output_file )

    # get little string at one iteration
    # (safe if written object is not on memory)
    mail.pop do |str|
      print str
    end

    mail.delete
  end
end

#------------------------------------------------------------#

http = Net::HTTP.new( addr )
print http.get( '/' )
  # no start is OK. A connection is closed after get

#------------------------------------------------------------#

Net::HTTP.start( addr, port ) do |http|

  # write into file
  http.get( '/ja/', nil, output_file )

  # write into string
  str = ''
  http.get( '/ja/', nil, str )

  # ...is equal to
  header, str = http.get( '/ja/', nil, str )

  # or
  http.get2( '/ja/' ) do |f|
    header = f.header
    str = f.body
  end

  # or
  http.get2( '/ja/' ) do |f|
    header = f.header
    body = ''
    f.body do |s|
      body << s
    end
  end

  # post data
  header, body = http.post( '/cgi-bin/procdata.rb', 'data data data...' )

end

#------------------------------------------------------------#
